json validation:
  stage: test
  image: python:3.6-slim
  before_script:
    - pip install jsonschema
  script:
    - echo "Validating JSON files..."
    - python3 ./data/config/config_validator.py ./data/config/dev.json ./data/config/prod.json
    - echo "JSON files OK!"

sql validation:
  stage: test
  image:
    name: apache/airflow:1.10.12-python3.6
    entrypoint: [""]
  before_script:
    - export GOOGLE_APPLICATION_CREDENTIALS=/opt/airflow/secrets/service-account.json
    - mkdir /opt/airflow/secrets/
    - echo $CI_CD_SERVICE_ACCOUNT | base64 -d > $GOOGLE_APPLICATION_CREDENTIALS
  script:
    - python ./plugins/bq_sql/bq_sql_validator.py $(find -type f -name "*.sql" -path "./plugins/**")

formatter:
  stage: test
  image: python:3.6-slim
  except:
    refs:
      - master
  before_script:
    - pip3 install black==21.4b2
  script:
    - black --check --diff dags/ tests/ data/ plugins/

pylint:
  stage: test
  image: python:3.7-slim
  variables:
    PYTHON_ENV: .venv
  before_script:
    - mkdir -p public/badges public/lint
    - echo undefined > public/badges/$CI_JOB_NAME.score
    - |
      pip install virtualenv anybadge
      virtualenv -p $(which python3) $PYTHON_ENV
      source $PYTHON_ENV/bin/activate
      pip install -r requirements-dev.txt
    - |
      export PYTHON_FILES=$(find -type f -name "*.py" -path "./dags/**" -or \
        -type f -name "*.py" -path "./tests/**" -or \
        -type f -name "*.py" -path "./data/**" -or \
        -type f -name "*.py" -path "./plugins/**" ! -name "__init__.py")
  script:
    - source $PYTHON_ENV/bin/activate
    - pylint --exit-zero --output-format=text $PYTHON_FILES | tee /tmp/pylint.txt
    - sed -n 's/^Your code has been rated at \([-0-9.]*\)\/.*/\1/p' /tmp/pylint.txt > public/badges/$CI_JOB_NAME.score
    - pylint --exit-zero --output-format=pylint_gitlab.GitlabCodeClimateReporter $PYTHON_FILES > codeclimate.json
    - pylint --exit-zero --output-format=pylint_gitlab.GitlabPagesHtmlReporter $PYTHON_FILES > public/lint/index.html
  after_script:
    - anybadge --overwrite --label $CI_JOB_NAME --value=$(cat public/badges/$CI_JOB_NAME.score) --file=public/badges/$CI_JOB_NAME.svg 4=red 6=orange 8=yellow 10=green
    - |
      echo "Your score is: $(cat public/badges/$CI_JOB_NAME.score)"
  artifacts:
    paths:
      - public
    reports:
      codequality: codeclimate.json
    when: always

unit tests CC:
  stage: test
  image:
    name: apache/airflow:1.10.15-python3.7
    entrypoint: [""]
  script:
    - scripts/tests_ci.sh
  allow_failure: true
